/***************************************************************************\
|*                                                                         *|
|*  Global.h: Global header file for MUNDI multi-player-ing routines.      *|
|*                                                                         *|
|*  New locations of kinda-pseudo-global bits of #definable switches:      *|
|*	DEBUG:			daemon.c				   *|
|*	DEVELOPMENT:		mundi.h					   *|
|*	KLUDGE_PROTOCOL:	mundi.h					   *|
|*	NONBLOCKING:		mundi.h					   *|
|*	CAPITALISE:		persona.h				   *|
|*	MIRKCHEAT:		persona.h				   *|
|*	DONTKILL:		mundi.h					   *|
|*	HARVDELETE:		mundi.h
|*                                                                         *|
|*	STARTUP_FILE:		mundi.h					   *|
|*	GLOBAL_STARTUP:		mundi.h					   *|
|*	BIN_DIR:		mundi.h					   *|
|*	INFO_DIR:		mundi.h					   *|
|*	PASSWDFILE:		persona.h				   *|
|*	LOGFILE:		daemon.h				   *|
|*                                                                         *|
\***************************************************************************/


#ifdef PRIVATE
#  define INETPORT 12373
#  define HOSTMACHINE "lily"
#  define MUNDI_DIR "/home/lily/ma/ulx/TestMundi"
#  define MUNDI_DIR_GLOBAL "/home/lily/ma/ulx/TestMundi"
#  define GAMESOK "/bin/true"
#else
#  define INETPORT	12372
#  define HOSTMACHINE	"blunder.tecc.co.uk" /* 2001: was "lily" (Warwick) */
				/* The first directory are for binaries */
#  define MUNDI_DIR	"/home/staff/mike/src/mundi"
			/* 2001: Was "/usr/local/games/lib/mundi" */
				/* This is for hhelp and global startup */
#  define MUNDI_DIR_GLOBAL MUNDI_DIR
			/* 2001: Was "/home/lily/cs/uwn/open/lib/mundi" */

				/* Check gamesok */
#  define GAMESOK_ "/usr/local/gamesok"
#  define GAMESOK "/bin/true"
#  define CHECK_DAEMON_LOADOK
#  define CHECK_CLIENT_LOADOK
#endif


				/* Arch-wizards uid's that may log in even */
				/* if load average is cheesed up */

#define BELL		'\007'	/* Control-G */
#define ESCAPE		'\033'	/* Control-[ by convention. */

#define CONNECTION	"\033@"	/* Connection successfully made to daemon */
#define NO_CONNECTION	"\033A"	/* Too many people are already playing */
#define QUIT_MUNDI	"\033B"	/* Client/daemon connection being broken */
#define EXORCISED	"\033C"	/* Client has been thrown off by a wizard */
#define SLEEPING	"\033D"	/* Client process has been suspended */
#define WOKEN		"\033E"	/* Client process has resumed execution */
#define SUPEREXED	"\033F"	/* Client has been logged out by a wizard */
#define PERSONABUSY	"\033G"	/* Persona requested is already in game */
#define NAMEISVERB	"\033H"	/* Persona name requested is a command */
#define NAMEISNOUN	"\033I"	/* Persona name requested is an object */
#define ACCOUNTEXISTS	"\033J"	/* Persona requested already exists */
#define NOACCOUNT	"\033K"	/* Persona requested does not yet exist */
#define PWMATCH		"\033L"	/* Password supplied matches correct one */
#define NOPWMATCH	"\033M"	/* Password does not match correct one */
#define PCREATED	"\033N"	/* Persona has been created */
#define CHANGE_PERSONA	"\033O"	/* Persona being used has changed */
#define CHANGE_LOCATION	"\033P"	/* Current location has changed */
#define NUCLEAR_DEATH   "\033Q" /* Killed by nuclear bomb ;-) */
#define GUN_DEATH       "\033R" /* Killed by a gun */
#define KILL_DEATH      "\033S" /* Killed by other weapon */
#define SHORTNAME	"\033T" /* Name is too short */
#define SIMILARNAME     "\033U" /* Name is similar to someone else playing */
#define IMPLODED	"\033V" /* Died from lack of food */
#define VOMITTEDON	"\033W"	/* You have been vomited on */
#define EXPLODED	"\033X" /* You have died from exploowding */
#define DIED		"\033Y" /* Died for some reason */
#define TOOBUSY		"\033Z" /* Daemon is too busy (load average) */
#define LISTPLAYERS	"\033a"	/* List players on game! */
#define NOTOPEN		"\033b"	/* Game is not open - return time when */
				/* open today - or next year! */

/****************************************************************************\
|*                                                                          *|
|*  NB.  In the above definitions we do not use CTRL-G (bell), CTRL-H       *|
|*       (backspace), CTRL-I (tab), CTRL-J (linefeed), CTRL-M (return),     *|
|*       CTRL-N (newline), CTRL-S & CTRL-Q (flow-control).  These could     *|
|*       otherwise cause confusion when sent to the client, and indeed,     *|
|*       as James so rightly points out, they did.                          *|
|*                                                                          *|
|*  NB.  All of the above is now irrelevant, since I have changed mundi to  *|
|*       send and recieve single characters preceded by ESCAPE instead.     *|
|*                                                                          *|
\****************************************************************************/

#define MAXUSERS	50	/* Maximum number of clients total */
#define MAXARGS		10	/* Number of cmd-line arguments remembered */
#define MAXBACKLOG	5	/* Maximum number of clients waiting */
#define MAXHISTORY	20	/* Maximum number of commands remembered */
#define MAXDIRECTIONS	20	/* Maximum number of directions */
#define MAXLOCATIONS	200	/* Maximum number of locations */
#define MAXOBJECTS	200	/* Maximum number of objects */
#define MAXCOMMANDS     200	/* Maximum number of commands */
#define MAXHOWS         200     /* Maximum number of hows */
#define SYNONYMS	15	/* Maximum number of equivalent words */
#define MAXSAYINGS      200	/* Maximum number of sayings */
#define MAXSHOUTS	200	/* Maximum number of shouts */

#define NAMELEN		12	/* Maximum length of MUNDINAME */
#define PWLEN		12	/* Maximum length of password */
#define CODELEN		12	/* Maximum length of user-code */
#define HOSTLEN		12	/* Maximum length of remote host */
#define PHYSLEN		40	/* Maximum length of physical description */
#define HAIRLEN		12	/* Maximum length of hair-colour */
#define EYELEN		12	/* Maximum length of eye-colour */
#define SEXLEN		1	/* Maximum length of sex */

#define DESCLEN		2048	/* Maximum length of location description */
#define LINELEN		160	/* Maximum length of broadcast line */
#define WORDLEN		20	/* Maximum length of a noun/verb etc. */
#define INDENT		2	/* Depth of each indentation level */
#define TABS		LINELEN	/* Maximum width of tab function */
#define NO_ONE		MAXUSERS /* The impossible user-number */

#define STARTLOC	1	/* Location where players enter game */
#define PITLOC		13	/* Location where treasure scores */
#define UPITLOC		3	/* Location where treasure reappears! */
#define WASTELOC	44	/* Location describing nuclear wasteland */
#define STORELOC	48	/* Location describing wizards' store */

/*--------------------------------------------------------------------------*/

#define DAYSINWEEK	7	/* Days in a week */
#define HOURSINDAY	24	/* Hours in a day */
#define MAXDAYLEN	4	/* Maximum name length of a day of week */

				/* Times in seconds for warning (scale) */
#define WARN1_TIME	1800	/* Time before logout for first */
				/* warning (Less than 3600) (minutes) */
#define WARN2_TIME      900	/* Time after first warning (minutes) */
#define WARN3_TIME      300	/* Third warning time (minutes) */
#define WARN4_TIME	60	/* Fourth warning time (seconds) */
#define WARN5_TIME	15	/* Final warning (seconds) */

#define MIN_WIZLEVEL	14	/* 14th level minimum for wizard */


/*--------------------------------------------------------------------------*/

#define say(string)		safewrite (playerno, string)

/*--------------------------------------------------------------------------*/


extern int errno;		/* The last error genated by a system call. */
extern int sys_nerr;		/* The total number of errors known. */
#ifdef sparc			/* 2001: Linux declares this itself.
				   The test for `sparc' is not really
				   right, but close enough */
extern char *sys_errlist[];	/* I don't know what's wrong with char** */
#endif

/*--------------------------------------------------------------------------*/

#if defined(sun3)
static char arch[] = "sun3";
#elif defined(sun4)
static char arch[] = "sun4";
#elif defined(sparc)		/* 2001: Added this branch */
static char arch[] = "sparc";
#elif defined(i386)		/* 2001: Added this branch */
static char arch[] = "i386";
#endif


/*
 * 2001: Turns out that the daemon makes fairly extensive use of the
 * BSD-specific signal enhancements sigsetmask() etc., which aren't in
 * Solaris 2.6.  My hunch is that we can just turn all this stuff off
 * and use sigset() instead of signal(), and the new semantics will Do
 * The Right Thing.
 */
#ifdef sparc
#define signal(sig, disp) (sigset((sig), (disp)))
#define sigmask(sig) 1
#define sigblock(mask) 1
#define sigsetmask(mask) 1
#endif

/*
 * 2001: I used BADSIG throughout, which I guess is yet another
 * BSD-ism.  This isn't defined in Solaris 2.6, so use the standard
 * equivalent.
 */
#define BADSIG (SIG_ERR)

/*
 * 2001: FIONREAD is not by default defined by Solaris.  You can get
 * <sys/ioctl.h> to define it if you defined BSD_COMP before
 * #including it, but then you run into all sorts of horrible symbol
 * redefinition problems with <termios.h>.  So here I just go ahead
 * and hard-define the right value ### FOR SPARC SOLARIS 2.6 ONLY!
 */
#if !defined(FIONREAD)
#  if defined(sparc)
#    define FIONREAD 0x4004667f
#  elif defined(i386)
#    define FIONREAD 0x541b
#  endif
#endif
