/***************************************************************************\
|*									   *|
|*  Plist.c:	List the mundi password file.  I might as well let	   *|
|*		this code be generally available, and list passwords,	   *|
|*		since no-one except me can read the password file.	   *|
|*  Re-started:	Tue Jun 13 16:22:33 BST 1989				   *|
|*									   *|
\***************************************************************************/

#include <stdio.h>
#include <fcntl.h>
#include <sys/types.h>
#include "global.h"
#include "persona.h"

/*-------------------------------------------------------------------------*/

main ()
{
  struct persona buffer;
  char pathname[LINELEN];

  int status;			/* Return value of system-calls */
  int fd;			/* File-descriptor to the passwd file */

  (void) sprintf ( pathname, "%s/%s", MUNDI_DIR, PASSWDFILE );

  if ((fd = open ( pathname, O_RDONLY)) == -1) {
    perror ("Couldn't open password file");
    exit (1);
  }

  while ((status = read (fd, &buffer, sizeof (struct persona))) > 0)
    (void) printf ("Record# %d\tName: \"%s\"\tPassword: \"%s\"\tWiz: %d\n",
		   buffer.record_no, buffer.name, buffer.passwd,
		   buffer.wizstuff);

  if (status == -1) {
    perror ("Error reading password file");
    exit (2);
  }

  exit (0);
}

/*-------------------------------------------------------------------------*/
