/***************************************************************************\
|*                                                                         *|
|*  Process.h:	Module to preprocess input lines before sending to daemon. *|
|*		This version started about 12th June 1988.		   *|
|*                                                                         *|
\***************************************************************************/

#undef	NULL_ISSPACE		/* '\0' is not a whitespace character. */
#define ALIAS_WORDS		/* Only substitute aliases for whole words */
#define MAXHISTORY 20		/* Maximum number of commands remembered */
#define PROMPT_STRING "[%M]<%h> "

/***************************************************************************\
|*                                                                         *|
|*  The following is a kludge to simulate the daemon's concept of a        *|
|*  player[].clientmode, so that we can enter help-mode in the test        *|
|*  harness.  This should be deleted when the daemon comes back.           *|
|*  (It is also hightly doubtful whether these are in the right place)     *|
|*                                                                         *|
\***************************************************************************/

#define PLAYING 0
#define INFO 1

/***************************************************************************\
|*                                                                         *|
|*  The following macro is used if we find a META_CHAR at the start of     *|
|*  a line of input, and returns true if its argument is a character       *|
|*  which, when following META_CHAR has no significant meaning.		   *|
|*                                                                         *|
\***************************************************************************/

#define NOT_SPECIAL(c)	(((c) != *META_CHAR) && ((c) != *BEFORE_CHAR))

/***************************************************************************\
|*                                                                         *|
|*  The following macros are for manipulating indices into the history     *|
|*  table.  The global variable current is a continually-increasing        *|
|*  history number, and the MAP macro maps it onto an index into the       *|
|*  history table (ie. between 0 and MAXHISTORY-1 inclusive).  Given       *|
|*  expressions in this range, the PREVIOUS and NEXT decrease and          *|
|*  increase the value by one respectively, wrapping round if the new      *|
|*  value would otherwise fall off the end of the table.                   *|
|*									   *|
\***************************************************************************/

#define PREVIOUS(this)	(((this) == 0) ? (MAXHISTORY-1) : ((this)-1))
#define NEXT(this)	(((this) == MAXHISTORY-1) ? (0) : ((this)+1))
#define MAP(this)	(((this)+MAXHISTORY) % MAXHISTORY)

/*-------------------------------------------------------------------------*/

struct Alias {			/* Each alias is stored in this stucture */
  char name[WORDLEN];		/* The word to be expanded */
  char expand[LINELEN];		/* The string to expand it to */
  struct Alias *next_ptr;	/* Pointer to next element of alias list */
};

/*-------------------------------------------------------------------------*/

extern void print_prompt ();
extern void init_process ();
extern int handle_line ();

extern int source_fd;		/* -1 if not sourcing, file fd otherwise */

/*--------------------------------------------------------------------------*/





