/****************************************************************************\
  This file will eventually contain an event scheduler. The events that
  can be generated would specific function calls, perhaps with arguments etc.

  This file was written in about 4 hours, together with events which took
  another 4 hours or so.... not bad for a chicken programmer like me, you
  gotta admit. Im sorry if this sounds big headed, but you gotta admit
  that as far as programming is concerned, Im FROGGING good.

  Tea off Im having a vast ego trip..... besides events are cool.

  Max.

  By the way dont ask me how it works - it just does it...

\****************************************************************************/

#include <sys/types.h>
#include <signal.h>
#include <string.h>
#include "global.h"
#include "daemon.h"
#include "schedule.h"
#include "persona.h"
				/* The event list - which is ordered by */
				/* time. The next event to occur should */
				/* appear at the front of the list. */

typedef struct _event_ {
    struct timeval  when;	/* At what time to schedule this event */
    EVF		   *func;	/* Function to call */
    char          **args;	/* Argument vector */
    struct _event_ *next;	/* Next event in scheduler */
} EVENT;

static EVENT *events;		/* List of events yet to happen */

static EVENT *queue;		/* List of events which must be executed */
				/* or have not been executed yet (and  */
				/* their time has passed!) */

static int m_old;		/* Old mask */

/****************************************************************************\
  List events times...
\****************************************************************************/

void show_events ( playerno )
    int playerno;
{
    struct itimerval first;
    EVENT *ptr;
    int i = 0,
	s = 0,
        u = 0;

    if ( !ARCHMODEP (playerno ) || ! events ) {
	say ( "Nope - there are deffinately no events here...\n" );
	return;
    }
    
    for ( ptr = events; ptr != 0; ptr = ptr->next, i++ ) {
	if ( ptr == events ) {
	    getitimer ( ITIMER_REAL, &first );
	    s += first.it_value.tv_sec;
	    u += first.it_value.tv_usec;
	} else {
	    s += ptr->when.tv_sec;
	    u += ptr->when.tv_usec;
	}
/*	say ( form ( "Event #%d, in %d.%6.6d\n", i, s, u ) );*/
	say ( form ( "Event #%d (arg0='%s'), in %d.%6.6d\n", i, ptr->args[0], s, u ) );/*2001*/
    }
}

/****************************************************************************\
  This function simply forces the next event to fall of the event queue.
\****************************************************************************/
void kludge_events ( playerno, command )
    int playerno;
    char *command;
{
    int no = 0;
    if ( !ARCHMODEP(playerno) ) {
	say ( "Naaah - only the Arch-wizards can kludge Mundi!\n" );
	return;
    }

    if ( *command != '\0' )
	no = atoi ( command );
    
    if ( no == 0 )
	no++;

    say ( form ( "Thrown away %d events.\n", no ) );

    for ( ; no > 0; no-- )
	kill ( getpid (), SIGALRM );
}

/****************************************************************************\
  This function recomputes when the next event is to happen, and sets the 
  timer for this. 

  This is the time of the first event in the list. 
  1) If no event at front of list then no events are to be produced and
     the timer is switched off.

  2) If the timer was not currently running, then we simply set up
     the timer for the first (and must be only) event.

  3) If the timer was running, then a new event must have been placed at
     the front. The timer should be reset to this value.

\****************************************************************************/

static void recompute_next ()
{
    struct itimerval next;
    timerclear ( &(next.it_interval) );

    if ( events ) {
	next.it_value    = events->when;
				/* Zero time is NOT allowed */
	if ( next.it_value.tv_sec == 0 && next.it_value.tv_usec < 10000 ) {
	    kill ( getpid (), SIGALRM );
	    return;
	}
    } else
	timerclear ( &(next.it_value) );

    setitimer ( ITIMER_REAL, &next, 0 );
}

/****************************************************************************\
  This function calls blocks SIGALRM - this should be put before 
  anything that must be executed safe from events - usually the whole
  program!
\****************************************************************************/

void block_events ()
{
    m_old = sigblock ( sigmask ( SIGALRM ) );
}

/****************************************************************************\
  This unblock SIGALRM - do it wherever SIGALRM can happen, or before
  check_events ()
\****************************************************************************/

void unblock_events ()
{
    sigsetmask ( m_old );
}

/****************************************************************************\
  Trap SIGALARM, this means we must transfer the first entry on the event
  list - but this would be rather dangerous - but luckily signals are
  blocked in any of the handler sections.
\****************************************************************************/
static void sigalarm ()
{
    EVENT *ptr;
    int mold;
    signal ( SIGALRM, sigalarm );
    mold = sigblock ( sigmask ( SIGALRM ) );    

    if ( events ) {
				/* Add event onto queue - for immeadiate */
				/* execution. */
	if ( queue ) {
				/* Find tail */
	    for ( ptr = queue; ptr->next != 0; ptr = ptr->next )
		;
	    ptr->next = events;	/* Add first event in list */
	    events = events->next;	/* events now begins at next in list */
	    ptr->next->next = 0;	/* End queue list */
	} else {
				/* Empty queue */
	    queue = events;	/* Make one */
	    events = events->next;
	    queue->next = 0;
	}
	recompute_next ();	/* Recompute next event */
    } else			/* Error - no events */
	logerror ( "Scheduler: SIGALRM with no event.\n" );
	

    sigsetmask ( mold );
}

/****************************************************************************\
  This function executes all the events in the queue, and deletes the
  queue. This must performed when select is EINTR by any signal (just
  in case it was a SIGALRM), or atleast once every second.
\****************************************************************************/

int check_events ()
{
				/* No SIGALRM */
    int    mold = sigblock ( sigmask ( SIGALRM ) );
    EVENT *ptr = queue,		/* For traversing queue */
          *old;			/* For deleting events */
    int    done = 0;		/* Howmany events done */

    while ( ptr ) {
				/* Call the event - with your args */
	(ptr->func) ( ptr->args );
	done++;			/* Done it */
				/* Free args */
	{
	    int i,
	        num = strlen ( (ptr->args)[0] ) + 1;

	    for ( i = 0; i < num; i++ )
		free ( (ptr->args)[i] );
	    
	    free ( ptr->args );
	}

	old = ptr;
	ptr = ptr->next;	/* Next thing in the list */
	free ( old );		/* Free that last one */
    }

    queue = 0;			/* Empty queue now! */
    sigsetmask ( mold );	/* Allow SIGALRM */

    return ( done );
}

/****************************************************************************\
  Initialise event list to be empty
\****************************************************************************/

void init_events ()
{
    events = 0;
    queue  = 0;

    if ( signal ( SIGALRM, sigalarm ) == BADSIG ) {
	logerror ( "Scheduler: Could not trap SIGALARM\n" );
	die ( 11 );
    } else
	logerror ( "Scheduler: Initialised\n" );
}

/****************************************************************************\
  This function adds the second timeval to the first timeval.
\****************************************************************************/

static void add_timeval ( ut, vt )
    struct timeval *ut,
                   *vt;
{
    ut->tv_usec += vt->tv_usec;
    ut->tv_sec  += vt->tv_sec + (ut->tv_usec / 1000000);
    ut->tv_usec %= 1000000;
}

/****************************************************************************\
  This function subtracts the second timeval from the first.
\****************************************************************************/

static void sub_timeval ( ut, vt )
    struct timeval *ut,
	           *vt;
{
    ut->tv_usec -= vt->tv_usec;
    ut->tv_sec  -= vt->tv_sec;
    if ( ut->tv_usec < 0 ) {
	ut->tv_sec--;
	ut->tv_usec += 1000000;
    }
}

/****************************************************************************\
  This function adds another event to happen in a given time span.
  A macro is defined if you want to execute something in the future
  by specifying the actual time.

  The event list contains a list of ordered events, in which the 
  "when" value is the time to wait before executing this event (from the
  time which the last event was executed).

  Eg.

  Event #	When
     0		15.000		This will happen in 15 seconds from now
     1           7.500          This will happen in 22.5 seconds from now
     2           7.500          This will happen in 25 seconds from now

  If a new event is to be added to happen in 20 seconds from now...

  Event #       When
     0(0)        15.000 (15.000)
     1(new)       5.000 (20.000 - 15.000)
     2(1)         2.500 (22.500 - 20.500)
     3(2)         7.500 (not changed)


     A call to this function MUST have the form;

     add_event ( sec, usec, func, format, args ... );

     Where sec  = number of seconds till event
           usec = number of micro-seconds till event

	   func = function to call.

	   format = format of arguments;
	               s - denotes string
		       c - denotes char
		       d - denotes int

	   args = list of args corresponding to format


    eg.

    add_event ( sec, usec, ev_saytoplayer, "ds", 5, "chicken" );
    add_event ( sec, usec, ev_saytoroom, "dss", 5, "chicken", "!\n" );

    Notice that the function must use a special reader - not unlike
    varargs, which is defined in schedule.h

\****************************************************************************/

void add_event ( sec, usec, func, va_alist )
    int            sec;		/* Seconds before event */
    int		   usec;	/* Micro seconds before event */
    EVF           *func;
    va_dcl			/* No ; !!! */
{
				/* Block SIGALRM signals */
    int      mold = sigblock ( sigmask ( SIGALRM ) );
    EVENT   *this = (EVENT *) malloc ( sizeof ( EVENT ) );
    EVENT   *ptr,
            *prev = 0;
    struct timeval   total;	/* For totalling the time in the list */
    struct timeval   when;	/* When event is supposed to occur */
    struct itimerval done;	/* How much of the timer has been done */

				/* No zero times allowed */
    if ( sec == 0 && usec < 10000 )
	usec = 10000;

    when.tv_sec  = sec;
    when.tv_usec = usec;

    timerclear ( &total );

    if ( this == 0 ) {
	logerror ( "Schedule: No memory for event.\n" );
	die ( 12 );
    }
				/* Initialise event info */
    this->when = when;
    this->func = func;

				/* This horrible code saves the arguments */
    {
	va_list  pvar;		/* For traversing arguments */
	char    *format;	/* Argument format passed */
	char    *s_arg;		/* String arg */
	char     c_arg;		/* Char arg */
	int      i_arg;		/* Int arg */
	char    *ptr;		/* Pointer to arg type */
	int      n_args;	/* Number of arguments passed */
	int      i;
				/* Argument format; */
				/* s = string */
				/* c = char */
				/* i = int */
				/* eg. "scsi" -> char *, char, char *, int  */
	va_start(pvar);
				/* Get format */
	format = va_arg(pvar, char*);
	n_args = strlen ( format );
				/* Add format to args */
	this->args = (char **) malloc ( sizeof ( char * ) * (n_args+1) );
	*(this->args) = (char *) strdup ( format );
				/* Traverse arguments */
	for ( i = 1, ptr = format; *ptr; ptr++, i++ ) {
	    switch ( *ptr ) {
	    case 's':
		s_arg = va_arg(pvar, char*);
		(this->args)[i] = (char *) strdup ( s_arg );
		break;
	    case 'c':
		c_arg = va_arg(pvar, char);
		(this->args)[i] = (char *) malloc ( sizeof ( char ) );
		*(this->args)[i] = c_arg;
		break;
	    default:
		i_arg = va_arg(pvar, int);
		(this->args)[i] = (char *) malloc ( sizeof ( int ) );
		*((int *)((this->args)[i])) = i_arg;
		break;
	    }
	}
	va_end(pvar);
    }

    if ( events == 0 ) {
				/* No events - make a list */
	events = this;
	this->next = 0;
	recompute_next ();	/* Recompute next event */
	goto finish;
    }

				/* Not a new list - gotta fish it! */

				/* We MUST set the first time to */
				/* the current timer value - such */
				/* that the values in the list are */
				/* correct. */

    getitimer ( ITIMER_REAL, &done );
    events->when = done.it_value;

				/* Search for correct position in list */
    for ( ptr = events; ptr != 0; ptr = ptr->next ) {
				/* Add up time */
	add_timeval ( &total, &(ptr->when) );

				/* Stop when total time in the event queue */
				/* is greater than when! */
	if ( timercmp ( &total, &when, > ) ) {
				/* Deduct the time (cos its the next one) */
				/* from the total  */
	    sub_timeval ( &total, &(ptr->when) );
	    break;
	}

	prev = ptr;		/* Remember previous */
    }
				/* Assert: total contains time upto prev */
				/* event */

				/* Make the time the next time for call */
    sub_timeval ( &(this->when), &total );

    if ( prev ) {
				/* If adding into list */
	prev->next = this;
	this->next = ptr;
    } else {
				/* Adding at front */
	this->next = events;
	events = this;
    }
    
				/* Fix next (if one) time */
    if ( this->next )
	sub_timeval ( &(this->next->when), &(this->when) );

				/* If adding at front we will need to */
				/* recompute_next (), otherwise not needed */
    if ( ! prev )
	recompute_next ();
 finish:
				/* Unblock SIGALRM */
    sigsetmask ( mold );
}



