#ifndef va_dcl			/* Cheesing varargs! */
#include <varargs.h>
#endif
#include <sys/time.h>

typedef void EVF();		/* Event function */
				/* Takes a va_list as argument */

extern void init_events ();	/* Initialise event handler */
extern void add_event ();	/* Add a new event to events scheduler */
extern int  check_events ();	/* Checks to see if any events are/needed */
				/* to be executed - returns number executed. */
extern void block_events ();	/* Block event handling */
extern void unblock_events ();	/* Unblock event handling */

extern void show_events ();	/* Say events... */
extern void kludge_events ();	/* Kludge events - unblock froggin queue */
				/* We would block events after a select has */
				/* fallen through, and unblock before the */
				/* select call, and before any */
				/* check_events() */

/****************************************************************************\
  How to define event functions; (similar to varargs)

void ev_function ( ev_alist )
     ev_dcl
{
    ev_list pvar;

    ev_start(pvar);

    ev_typeof ( pvar ) == STRING, CHAR, or INT
    
    ev_string(pvar)
    ev_char(pvar)
    ev_int(pvar)

    ev_end(pvar);
}

\****************************************************************************/

#define STRING 's'
#define CHAR   'c'
#define INT    'd'

#define ev_dcl char **ev_alist;

typedef struct {
    char **alist;		/* Where your arg list is */
    int   c;			/* Which argument we are at man! */
} ev_list;

#define ev_start(xxx) ((xxx).alist = ev_alist, (xxx).c = 1)
#define ev_typeof(xxx) (((xxx).alist)[0][(xxx).c-1])
#define ev_string(xxx) (((xxx).alist)[(xxx).c++])
#define ev_char(xxx)  (*(((xxx).alist)[(xxx).c++]))
#define ev_int(xxx)  (*((int *)(((xxx).alist)[(xxx).c++])))
#define ev_isend(xxx) (((xxx).alist)[0][(xxx).c-1] == '\0')
#define ev_end(xxx)


