/***************************************************************************\
|*                                                                         *|
|*  Verbs2.c:	Part of the server program for MUNDI			   *|
|*		This module will handle some the routines for verbs	   *|
|*		that are not magical in nature, and which are builtins,	   *|
|*		ie. are not defined in the ADL				   *|
|*  Started:	Mon Dec 11 23:02:57 GMT 1989				   *|
|*                                                                         *|
\***************************************************************************/

#include <sys/types.h>
#include <strings.h>

#include "global.h"
#include "daemon.h"
#include "persona.h"
#include "handle.h"
#include "look.h"
#include "utils.h"
#include "verbs.h"

/*-------------------------------------------------------------------------*/

extern char *sprintf ();
extern long random ();

/*-------------------------------------------------------------------------*/

void fire ( playerno, command )
int playerno;
char *command;
{
    char victimstr[LINELEN];
    char itemstr[LINELEN];
    int victim, b;
    int item;

    getnextword ( victimstr, command );
    
    if ( *victimstr == '\0' ) {
	say ( "Fire at whom?\n" );
	return;
    }

    if ((victim = strtoplayer (victimstr)) == -1) {
	say ( form ( "There is no-one called \"%s\" logged in.\n",
		    victimstr ) );
	return;
    }

    if ( victim == playerno ) {
	say ( "Suicide is right out Im afraid!\n" );
	return;
    }
				/* Witty - arches can fire at anyone */
    if ( !ARCHMODEP ( playerno ) ) {
	if ( player[playerno].where != player[victim].where ) {
	    say ( form ( "%s isn't here!\n", player[victim].name ) );
	    return;
	}
    }

    if ( player[playerno].where == 0 || player[victim].where == 0 ) {
	say ( "Limbo is a safe location - no firing allowed\n" );
	return;
    }

    getnextword ( itemstr, command );
    if ( samenstring ( itemstr, "with" ) )
	getnextword ( itemstr, command );

    if ( *itemstr == '\0' ) {
	say ( "Shoot what you vomit head!\n" );
	return;
    }

    if ( (item = strtonoun ( itemstr, player[playerno].where ) ) == -1 ) {
	say ( form ( "There is no such object \"%s\" in the game.\n",
		    itemstr ) );
	return;
    }

    if ( ! reallyheld ( item, playerno ) ) {
	say ( form ( "You arn't holding the %s you chicken head!\n",
		    itemstr ) );
	return;
    }
    if ( ! accessheld ( item, playerno ) ) {
	say ( form ( "You can't get at the %s!\n", itemstr ) );
	return;
    }
    if ( ! fireablep ( item ) ) {
	say ( form ( "The %s isn't a gun!\n", itemstr ) );
	return;
    }
    if ( ! moveablep ( item ) ) {
	say ( form ( "The %s is too heavy to weild!\n", itemstr ) );
	return;
    }

    if ( ! rollagainst ( playerno, -25, player[playerno].luck ) ) {
	say ( "The gun seems to be jammed!\n" );
	return;
    }

    say (form ("You fire the %s at %s.\n", itemstr, player[victim].name ) );
    safewrite ( victim, form ("%s fires the %s, at you.\n",
			      player[playerno].name, itemstr ));
    speak2 ( form ( "%s fires the %s at %s.\n",
		   player[playerno].name,
		   itemstr,
		   player[victim].name ), playerno, victim );

    if ( rollagainst ( victim, -100, player[victim].intelligence ) ) {
	safewrite ( victim, "You deflect the bullets with a spell!\n" );
	speak ( "The bullets have no effect!\n", victim,
	         player[victim].where );
	return;
    }

    b  = ((player[playerno].luck    - player[victim].luck) +
 	  (player[playerno].agility - player[victim].agility) ) / 25;

    if ( multishotp ( item ) ) {
	if ( ( b += random () % 12 ) > 12 )
	    b = 12;
    } else
	b = 1;

    if ( b > 0 ) {
	safewrite ( victim,
		   form ( "You are hit by %d high velocity bullet%c!\n",
			 b, PLURAL(b) ) );
	speak ( form ( "%s is hit by %d bullet%c!\n",
		      player[victim].name,
		      b, PLURAL(b) ), victim, player[victim].where);
	damage ( playerno, victim, b*obj[item].damage,
		GUN_DEATH, itemstr );
	return;
    }

    safewrite ( victim, "You are miracously unharmed as bullets ricoche all around!\n" );
    speak ( form ( "%s's deadly assualt completely misses %s!\n",
		  player[playerno].name,
		  player[victim].name ),
	   victim,
	   player[victim].where );
}

/*--------------------------------------------------------------------------*/

void attack ( playerno, victim, dam, weaponstr, weapon )
int playerno, victim, dam;
char *weaponstr, *weapon;
{
    int delta, temp;

    if ( change_intcont ( playerno, -1 ) )
	return;

    if ( WIZMODEP ( playerno ) )
	dam += ((dam >= 0) ? 10 : -10);

    if ( ARCHMODEP ( victim ) && !ARCHMODEP( playerno ) && ( dam > 0 ) ) {
	temp = victim;
	victim = playerno;
	playerno = temp;
    }

    if ( ARCHMODEP ( playerno ) && !ARCHMODEP ( victim ) ) {
	dam = ( ( dam >=0 ) ? player[victim].hp : ( player[victim].maxhp - player[victim].hp ) );
    }

    delta = 60 + player[playerno].intelligence;

    if ( rollagainst ( victim, -delta, player[victim].intelligence ) ) {
	say (form ("You attack %s, who successfully casts a defensive spell!\n",
		    player[victim].name ) );
	safewrite ( victim, form ( "\
%s attacks you, but you cast a defensive spell!\n" ,
				  player[playerno].name  ) );
	speak2 ( form ( "You see %s attack %s, who seems unaffected\n",
		       player[playerno].name,
		       player[victim].name ), playerno, victim );
	return;
    }

    say ( form ( "You attack %s with your %s.\n", player[victim].name,
		weapon ) );
    safewrite ( victim, form ( "%s attacks you with %s.\n", 
			      player[playerno].name,
			      weaponstr ));
    speak2 ( form ( "You see %s attack %s with %s.\n",
		   player[playerno].name,
		   player[victim].name,
		   weaponstr ),
	    playerno,
	    victim );
    delta = player[playerno].agility + (player[playerno].level * 5);
    if ( rollagainst ( victim, -delta, player[victim].agility ) ) {
	say ( form ( "%s evades your attack!\n", player[victim].name ) );
	safewrite ( victim, form ( "You evade %s's attack.\n", 
				  player[playerno].name ) );
	speak2 ( form ( "%s evades %s's attack!\n",
		       player[victim].name,
		       player[playerno].name ),
		playerno,
		victim );
	change_intcont ( victim, -1 );
	return;
    } 
    delta = player[playerno].level * 10;
    if ( rollagainst ( victim, -delta, player[victim].luck ) ) {
	dam /= 2;
	say ( form ( "%s partially evades your attack!\n",
		    player[victim].name ) );
	safewrite ( victim, form ( "You nearly evade %s's attack.\n", 
				  player[playerno].name ) );
	speak2 ( form ( "%s just manages to be caught by %s's attack!\n",
		       player[victim].name,
		       player[playerno].name ),
		playerno,
		victim );
	if ( change_intcont ( victim, -1 ) )
	    return;
    }

    damage ( playerno, victim, dam, KILL_DEATH, weapon );
}

/*--------------------------------------------------------------------------*/

void killperson ( playerno, victim, command )
int playerno;
int victim;
char *command;
{
    char weaponstr[LINELEN];
    char weapon[LINELEN];

    int dam = player[playerno].strength / 10 
	    + player[playerno].level * 2,
        wepno;

    getnextword ( weapon, command );
    
    if ( *weapon == '\0' ) {
	switch ( player[playerno].sex[0] ) {
	case 'f':
	case 'F':
	    strcpy ( weaponstr, "her " );
	    break;
	case 'm':
	case 'M':
	    strcpy ( weaponstr, "his " );
	    break;
	default:
	    strcpy ( weaponstr, "its " );
	    break;
	}
	strcat ( weaponstr, "fist" );
	attack ( playerno, victim, dam, weaponstr, "fist" );
        return;
    }
    strcpy ( weaponstr, "a " );

    if ( samenstring ( weapon, "with" ) )
	getnextword ( weapon, command );

    if ((wepno = strtonoun ( weapon, player[playerno].where )) == -1) {
	say ( form ( "What's a %s???\n", weapon ) );
	return;
    }

    strcat ( weaponstr, weapon );

    if ( ! reallyheld ( wepno, playerno ) ) {
	say ( form ( "You havn't got %s", weaponstr ) );
	return;
    }
    if ( ! accessheld ( wepno, playerno ) ) {
	say ( form ( "You can't get at the %s!\n", weaponstr ) );
	return;
    }
    if ( ! weaponp ( wepno ) && ! cursedweaponp ( wepno ) ) {
	say ( form ( "The %s is not a weapon!\n", weaponstr ) );
	return;
    }
    dam = obj[wepno].damage;
    if ( dam >= 0 )
	dam += (player[playerno].strength / 20
	        + player[playerno].level * 2 );
    else
	dam -= (player[playerno].intelligence / 20 
		+ player[playerno].level * 2 );

    attack ( playerno, victim, dam, weaponstr, weapon );
}

/*--------------------------------------------------------------------------*/

void killstring ( playerno, command )
int playerno;
char *command;
{
    char victimstr[LINELEN];
    int victim;

    /* kill <player> [with item] */

    getnextword ( victimstr, command );
    if ( *victimstr == '\0' ) {
	say ( "Kill whom, you frog-wimlet?\n" );
	return;
    }
    if (( victim = strtoplayer ( victimstr )) == -1 ) {
	say ( form ( "There is no-one called \"%s\" logged in.\n",
		    victimstr ) );
	return;
    }
    if ( victim == playerno ) {
	say ( "Hari-Kiri is not allowed here!\n");
	return;
    }
				/* Witty - allow arches to attack anyone
				   wherever they are! */
    if ( !ARCHMODEP ( playerno ) ) {
	if ( player[playerno].where != player[victim].where ) {
	    say ( form ( "%s isn't here!\n", player[victim].name ) );
	    return;
	}
    }
    if ( player[victim].where == 0 || player[playerno].where == 0 ) {
	say ( "Limbo is a safe location - no fighting here!\n" );
	return;
    }
    killperson ( playerno, victim, command );
}

/*--------------------------------------------------------------------------*/

void quaff ( playerno, command )
int playerno;
char *command;
{
    char itemstr[LINELEN], *repl;
    int item, power;

    getnextobject ( itemstr, command );
    if ( *itemstr == '\0' ) {
	say ( "Quaff what?\n" );
        return;
    }
    if (( item = strtonoun ( itemstr,
			    player[playerno].invloc ) ) == -1 ) {
	say ( form ( "There is nothing called \"%s\" in this game.\n",
		    itemstr ) );
	return;
    }
    if ( !reallyheld ( item, playerno ) ) {
	say ( form ( "Your not carrying the %s.\n", itemstr ) );
	return;
    }
    if ( !accessheld ( item, playerno ) ) {
	say ( form ( "You can't get at the %s!\n", itemstr ) );
	return;
    }
    if ( ! drinkablep ( item ) ) {
	say ( "You can't drink that!!!\n" );
	return;
    }
    power = obj[item].damage;
    say ( form ( "You drink the %s.\n", itemstr ) );
    obj[item].location = UPITLOC;

    if ( ( repl = heal_player ( playerno, power, 0 ) ) != 0 )
	say ( repl );

    if ( player[playerno].hp < 0 ) {
	safewrite ( playerno, form ( "%s\n", DIED ) );
	speak ( form ( "%s turns green, and falls over quite dead!\n",
		      player[playerno].name ),
	       playerno, player[playerno].where );
	shout ( form ( "*** %s has died from drink!\n",
		      player[playerno].name ), NO_ONE, MESG_GLOBAL );
	killoff ( playerno );
    }
}

/*--------------------------------------------------------------------------*/

void levels ( playerno )
    int playerno;
{
    int i, from, to;

    say ( "\
+--------------------------------+--------------+--------------+\n" );
    say ( "\
| Level                          |         From | To           |\n" );
    say ( "\
+--------------------------------+--------------+--------------+\n" );

    for ( i = 0; i < SC_LEVELS; i++ ) {
	from = sc_levels[i].minscore;
	to = sc_levels[i+1].minscore - 1;
	if ( i < (SC_LEVELS-1) )
	    say ( form ( "| %-30s | %12d | %-12d |\n", 
			sc_levels[i].name, from, to ) );
	else
	    say ( form ( "| %-30s | %12d | %-12.12s |\n",
			sc_levels[i].name, from, "Infinity" ) );
    }

    say ( "\
+--------------------------------+--------------+--------------+\n" );
}

/****************************************************************************\
  Steal your objects..... it should be very difficult for low level
  crud heads to do this.

  steal <item> from <person>

\****************************************************************************/

void steal ( playerno, command )
int playerno;
char *command;
{
    char itemstr[LINELEN];
    char victimstr[LINELEN];
    int item, victim, prob, cost;

    getnextword ( itemstr, command );
    if ( *itemstr == '\0' ) {
	say ( "Steal what?\n" );
        return;
    }
    if (( item = strtonoun ( itemstr, player[playerno].where )) == -1 ) {
	say ( form ( "There is nothing called \"%s\" in this game.\n",
		    itemstr ) );
	return;
    }
    getnextword ( victimstr, command );
    if ( strcmp ( victimstr, "from" ) == 0 )
	getnextword ( victimstr, command );
    if ( *victimstr == '\0' ) {
	say ( "Steal from who, you cretin!\n" );
	return;
    }
    if ( ( victim = strtoplayer ( victimstr ) ) == -1 ) {
	say ( form ( "There is no-one called \"%s\" logged in.\n",
		    victimstr ) );
	return;
    }
    if ( ARCHMODEP ( victim ) && !METAMODEP ( playerno )) {
	say ( "You cant steal from arch-wizards - frog off!\n" );
	return;
    }
    if ( victim == playerno ) {
	say ( "You cant steal from yourself - its silly!\n" );
	return;
    }
    if ( ! WIZMODEP(playerno) ) {
	if ( player[playerno].where != player[victim].where ) {
	    say ( form ( "%s isn't here!\n", player[victim].name ) );
	    return;
	}
    }
    if ( ! ARCHMODEP ( playerno ) ) {
	if ( player[victim].where == 0 || player[playerno].where == 0 ) {
	    say ( "You cant steal from/in limbo - frog off.\n" );
	    return;
	}
    }
    if ( !reallyheld ( item, victim ) ) {
	say ( form ( "%s not carrying the %s\n", 
		    player[victim].name, itemstr ) );
	return;
    }
    if ( !accessheld ( item, victim ) ) {
	say ( form ( "You can't steal %s from %s, its not accessible!\n",
		    itemstr, player[victim].name ) );
	return;
    }
    if ( !moveablep(item) ) {
	say ( form ( "You can't steal %s from %s, its immovable!\n",
		    itemstr, player[victim].name ) );
	return;
    }
    if (!ARCHMODEP(playerno)) {
	if ( (totallocweight(player[playerno].invloc)
	      + obj[item].weight ) > weight_limit(playerno) ) {
	    say ( "You can't carry as much as that!\n" );
	    return;
	}
    }
    /**********************************************************************\
      Now thats over I can actually steal the froggin item!!! phew.
      Oh and frog off if you dont like the code - its a ten minute hack
      in the style of real programmers... none of your fancy OOB vomit.
    \**********************************************************************/

    prob = ( player[playerno].level - player[victim].level ) * 5 - 40;

    if ( WIZMODEP ( victim ) )
	prob -= 40;

    if ( ! rollagainst ( playerno, prob, player[playerno].agility ) ) {
	say ( form ( "You fail to steal the %s from %s.\n",
		    obj[item].desc, player[victim].name ) );
	safewrite ( victim, 
		   form ( "%s fails to steal the %s from you.\n",
			 player[playerno].name,
			 obj[item].desc ) );
	speak2 ( form ( "%s fails to steal the %s from %s.\n",
		       player[playerno].name,
		       obj[item].desc,
		       player[victim].name ),
		playerno,
		victim );
	return;
    }

    if ( !ARCHMODEP (playerno ) 
	&& (player[playerno].where != player[victim].where) ) {
	cost = obj[item].value +
	       obj[item].weight * 10 +
	       obj[item].size * 10 +
	       obj[item].flag * 10 + 100;
	if ( ! castablep ( playerno, cost ) ) {
	    say ( "Frog off you aint got enough points!\n" );
	    return;
	}
    }
    obj[item].location = player[playerno].invloc;

    if ( change_purity ( playerno, 
			 - (  (obj[item].value / 100)
			    + (obj[item].damage * obj[item].flag) / 100) ) )
	say ( "FISH, evil cheese head. Watch out!\n" );

    say ( form ( "You steal the %s from %s!!!\n",
		    obj[item].desc, player[victim].name ) );
    safewrite ( victim, 
	       form ( "%s has stolen the %s from you!!!\n",
		     player[playerno].name,
		     obj[item].desc ) );
    speak2 ( form ( "%s steals the %s from %s!!!\n",
		   player[playerno].name,
		   obj[item].desc,
		   player[victim].name ),
	    playerno,
	    victim );
}

/****************************************************************************\
  Throw <object> <direction>

  Witty for throwing tnd at people, and for pitting treasure when tedious
  people insist on staying over the pit and killing all who may enter.

  Its also witty!
\****************************************************************************/


void throw ( playerno, command )
int playerno;
char *command;
{
    char itemstr[LINELEN];
    char dirstr[LINELEN];
    int item, dirno, newloc;

    getnextword ( itemstr, command );
    if ( *itemstr == '\0' ) {
	say ( "Throw what?\n" );
        return;
    }
    if (( item = strtonoun ( itemstr, player[playerno].invloc )) == -1 ) {
	say ( form ( "There is nothing called \"%s\" in this game.\n",
		    itemstr ) );
	return;
    }
    getnextword ( dirstr, command );
    if ( *dirstr == '\0' ) {
	say ( "Which direction you cretin?\n" );
	return;
    }
    if ( ( dirno = strtodir ( dirstr ) ) == -1 ) {
	say ( "Im sorry but we dont work in four dimensions around here!\n" );
	return;
    }
    switch ( newloc = getnewloc ( playerno, &dirno ) ) {
    case DIR_NOEXIT:
	say ( form ( "You can't throw %s here!\n",
		    dir[dirno].desc ) );
	return;
    case DIR_ATPIT:
	say ( "Your at the pit already!\n" );
	return;
    case DIR_NOPITDIR:
	say ( "I dont know the way to the pit from here!\n" );
	return;
    }
    dropitem ( playerno, item, "throw", newloc, dirno );
}

/*--------------------------------------------------------------------------*/

void give ( playerno, command )
int playerno;
char *command;
{
    char itemstr[LINELEN];
    char victimstr[LINELEN];
    int item, victim;

    getnextword ( itemstr, command );
    if ( *itemstr == '\0' ) {
	say ( "Give what?\n" );
        return;
    }
    if (( item = strtonoun ( itemstr, player[playerno].where )) == -1 ) {
	say ( form ( "There is nothing called \"%s\" in this game.\n",
		    itemstr ) );
	return;
    }
    getnextword ( victimstr, command );
    if ( strcmp ( victimstr, "to" ) == 0 )
	getnextword ( victimstr, command );
    if ( *victimstr == '\0' ) {
	say ( "Give to who, you cretin!\n" );
	return;
    }
    if ( ( victim = strtoplayer ( victimstr ) ) == -1 ) {
	say ( form ( "There is no-one called \"%s\" logged in.\n",
		    victimstr ) );
	return;
    }
    if ( victim == playerno ) {
	say ( "You cant give to yourself - its silly!\n" );
	return;
    }
    if ( ! WIZMODEP(playerno) ) {
	if ( player[playerno].where != player[victim].where ) {
	    say ( form ( "%s isn't here!\n", player[victim].name ) );
	    return;
	}
    }
    if ( !reallyheld ( item, playerno ) ) {
	say ( form ( "Your not carrying the %s.\n", itemstr ) );
	return;
    }
    if ( !accessheld ( item, playerno ) ) {
	say ( form ( "You can't get at the %s right now!\n", itemstr ) );
	return;
    }
    if ( !moveablep ( item ) ) {
	say ( form ( "The %s is immoveable!\n", itemstr ) );
	return;
    }
    if (!ARCHMODEP(victim) ) {
	if ( (totallocweight(player[victim].invloc)
	      + obj[item].weight ) > weight_limit(victim) ) {
	    say ( "They can't carry as much as that!\n" );
	    return;
	}
    }

    obj[item].location = player[victim].invloc;

    if ( change_purity ( playerno, 
			(   (obj[item].value / 100)
			 +  (obj[item].damage * obj[item].flag / 100) ) ) )
	say ( "Mr nice guy huh? :-)\n" );

    say ( form ( "You give the %s to %s!!!\n",
		    obj[item].desc, player[victim].name ) );
    safewrite ( victim, 
	       form ( "%s has given you the %s!!!\n",
		     player[playerno].name,
		     obj[item].desc ) );
    speak2 ( form ( "%s has given the %s to %s!!!\n",
		   player[playerno].name,
		   obj[item].desc,
		   player[victim].name ),
	    playerno,
	    victim );
}


/*--------------------------------------------------------------------------*/

void examine_persona (playerno, victim, pptr)
  int playerno;
  int victim;
  struct persona *pptr;
{
  int i, gotone = 0;
  char *heshe;
  
  if (victim != -1 && !ARCHMODEP(playerno) ) {
    safewrite (victim, form ("%s looks at you in an odd manner.\n",
			     player[playerno].name));
    speak2 (form ("%s looks at %s in an odd manner.\n",
		  player[playerno].name, player[victim].name),
	    playerno,
	    victim);
  }

  if (pptr->sex[0] == 'm') heshe = "He"; else
    if (pptr->sex[0] == 'f') heshe = "She"; else
      heshe = "(S)he";
  
  say (form ("You look at %s", person_sd (*pptr)));
  say (form ("%s is physically described as \"%s\".\n", heshe,
	     pptr->physical));
  say (form ("%s has %s eyes and %s hair.\n", heshe,
	     pptr->eyecolour, pptr->haircolour)); 
  if (victim != -1) {
    for (i = 0; i < no_objects; i++)
      if (obj[i].location == player[victim].invloc) {
	if (rollagainst (playerno, -30, player[playerno].intelligence)) {
	  if (!gotone)
	    say (form ("%s is carrying:\n", heshe));
	  printobject (playerno, i, 1);
	  gotone = 1;
	}
      }
  }
  
  if (!gotone)
    say (form ("%s is not carrying anything.\n", heshe,	player[victim].name));
}

/*--------------------------------------------------------------------------*/

void examine_object (playerno, objectstr)
    int playerno;
    char *objectstr;
{
    int ind, i;
    
    if ((ind = strtonoun (objectstr, player[playerno].where)) == -1) {
	say (form ("There isn't anything in the game called \"%s\"!\n",
		   objectstr));
	return;
    }
    
    if ((!WIZMODEP (playerno)) && (!visible (ind, playerno))) {
	say (form ("You can't see any %s, vomit head!\n", obj[ind].desc));
	return;
    }
    
    if ((!ARCHMODEP (playerno)) && (real_loc (ind) == UPITLOC)) {
	say (form ("Sorry, the %s has been pitted.\n", obj[ind].desc));
	return;
    }
    
    say (form ("You examine the %s ...\n", obj[ind].desc));
    speak ( form ( "%s looks at the %s in an odd manner.\n",
		  player[playerno].name, obj[ind].desc ) );

    if (!moveablep(ind))
	say ("It seems to be immovable!\n");

    if (wearablep(ind))
	say ("It could be worn.\n" );

    if ( weaponp(ind))
	say (form ("It is a weapon capable of %d hit points damage.\n",
		   obj[ind].damage));

    if ( singleshotp(ind) ) 
	say ( form ( "It is a single shot gun, each bullet doing %d damage.\n",
		    obj[ind].damage ) );
    
    if ( multishotp(ind) )
	say ( form ( "It is an automatic SMG, each bullet doing %d damage.\n",
		    obj[ind].damage ) );
	
    if ( nuclearp(ind) ) {
	say ( "It seems to be some kind of advance nuclear weaponary.\n" );
	say ( "There is a Radiation hazard warning printed on it.\n" );
    }

    if ( WIZMODEP(playerno) ) {
	if ( nuclearsavep(ind) )
	    say ( "\
It seems to have a magical power for resisting radiation blasts.\n" );
    }

    /* Cursed */
    if ( cursedweaponp(ind) ) {
	if ( !WIZMODEP(playerno) )
	    say (form ("It is a weapon capable of %d hit points damage.\n",
		       -obj[ind].damage));
	else
	    say (form ("It is a CURSED weapon of %d hit points restore.\n",
		       -obj[ind].damage));
    }
    
    if (treasurep(ind))
	say (form ("It is treasure, worth %d points.\n", obj[ind].value));
    
    if (WIZMODEP (playerno)) {
	if (antitreasurep(ind))
	    say (form ("It is an %d point anti-treasure!\n", -obj[ind].value));
	if (moveablep(ind)) {
	    say (form ("It weighs %d pounds.\n", obj[ind].weight));
	    say (form ("Its size is %d cubic things.\n", obj[ind].size));
	}
    } else {
       if (antitreasurep(ind))
 	   say (form ("It is treasure, worth %d points.\n", -obj[ind].value));
    }

    if (ediblep(ind))
	say ( "It is edible.\n" );

    if (drinkablep(ind)) {
	if ( WIZMODEP(playerno) && poisonp(ind) )
	    say ( "It is poisonous.\n" );
	else
	    say ( "It is drinkable.\n" );
    }

    if ( containerp(ind))
	if ( transparentp(ind))
	    say ("It is a transparent container.\n");
	else
	    say ("It is a container.\n");

    if (surfacep(ind))
	if (transparentp(ind))
	    say ( "It is a tranparent surface.\n" );
	else
	    say ( "It is a surface.\n" );

    if ( lockablep(ind) )
	say ( "It has a lock on it.\n" );

    if ( animatep (ind) ) {
	say ( "It seems have a life of its own.\n" );
	if ( WIZMODEP ( playerno ) ) {
	    if ( act_movep(ind) )
		say ( "It twists and turns, like a twisty turny thing.\n" );
	    if ( act_sayp(ind) || act_shoutp(ind) )
		say ( "It has some kind of mouth(?).\n" );
	    if ( act_stealp(ind) )
		say ( "It radiates a feeling of deviousness.\n" );
	    if ( act_givep(ind) )
		say ( "It is enimating a feeling of kindess.\n" );
	    if ( act_attackp(ind) )
		say ( "\
It looks a bit viscous, like its gonna rip your head off.\n" );
	}
    }

    printcontents ( playerno, ind, 0 );
}

/*--------------------------------------------------------------------------*/

void examine ( playerno, command )
    int playerno;
    char *command;
{
    char victimstr[LINELEN];
    int victim, number = 0;
    
    while ( *command != '\0' ) {
	number++;
	getnextobject (victimstr, command);
	
	if ((victim = strtoplayer (victimstr)) == -1) {   /* Not logged on! */
	    if ((!ARCHMODEP (playerno)) ||
		(victim = strtopersona (victimstr)) == -1 ) {
		examine_object (playerno, victimstr);
	    } else
		examine_persona (playerno, -1, &(persona_list[victim]));
	}
	else
	    if ((!WIZMODEP (playerno)) &&
		(player[playerno].where != player[victim].where))
		say (form ("%s isn't here!\n", player[victim].name));
	    else
		examine_persona (playerno, victim, &(player[victim]));
    }
    if ( ! number )
	say ("Examine who or what?\n");
}

/*--------------------------------------------------------------------------*/

void sayto ( playerno, command )
    int playerno;
    char *command;
{
    char victimstr[LINELEN], *realvictim;
    int victim;

    getnextword ( victimstr, command );
    if ( *victimstr == '\0' ) {
	say ( "Say something to who?\n" );
	return;
    }
    if ( ( victim = strtoplayer ( victimstr ) ) == -1 ) {
	if ( !ARCHMODEP ( playerno ) ) {
	    say ( form ( "There is no-one called  \"%s\" in the game!\n",
			victimstr ) );
	    return;
	} else {
	    int room;

	    if ( ( room = strtoroomcode ( victimstr ) ) == -1 ) {
		say ( form ( "There is no such room as %s!\n", victimstr ) );
		return;
	    }
	    if ( *command == '\0' ) {
		say ( "Say what?\n" );
		return;
	    }
	    say ( form ( "You say into %s; \"%s\".\n",
			loc[room].name,
			command ) );
	    speak ( form ( "Someone says; \"%s\".\n", command ), -1, room );
	    return;
	}
    }
    if ( ! WIZMODEP ( playerno ) ) {
	if ( player[victim].where != player[playerno].where ) {
	    say ( form ( "%s isn't here you vomit head!\n", 
			player[victim].name ) );
	    return;
	}
    }
    if ( *command == '\0' ) {
	say ( form ( "Say what to %s?\n", player[victim].name ) );
	return;
    }
    say ( form ( "You say to %s; \"%s\".\n",
		( playerno == victim ) ? "yourself" : player[victim].name,
		command ) );
    if ( playerno != victim )
	safewrite ( victim, form ( "%s says to you; \"%s\".\n",
				  player[playerno].name,
				  command ) );
    speak2 ( form ( "%s says something to %s.\n",
		   player[playerno].name,
		   ( playerno == victim ) ? "himself" : player[victim].name ),
	    victim,
	    playerno );
}

/*--------------------------------------------------------------------------*/

void fatness ( playerno )
    int playerno;
{
    int i, from, to;
    say ( "\
+----------------------+--------------+--------------+\n" );
    say ( "\
| Fatness              |         From | To           |\n" );
    say ( "\
+----------------------+--------------+--------------+\n" );

    for ( i = 0; i < FA_LEVELS; i++ ) {
	from = fa_levels[i].minscore;
	if ( i < (FA_LEVELS-1) )
	    to = fa_levels[i+1].minscore - 1;
	else
	    to = MAX_FATNESS;
	say ( form ( "| %-20s | %12d | %-12d |\n", 
		    fa_levels[i].name, from, to ) );
    }
    say ( "\
+----------------------+--------------+--------------+\n" );
}

/*--------------------------------------------------------------------------*/

void purity ( playerno )
    int playerno;
{
    int i, from, to;
    say ( "\
+----------------------+--------------+--------------+\n" );
    say ( "\
| Purity               |        From  | To           |\n" );
    say ( "\
+----------------------+--------------+--------------+\n" );
    for ( i = 0; i < PU_LEVELS; i++ ) {
	from = pu_levels[i].minscore;
	if ( i < (PU_LEVELS-1) )
	    to = pu_levels[i+1].minscore - 1;
	else
	    to = MAX_PURITY;
	say ( form ( "| %-20s | %12d | %-12d |\n", 
		    pu_levels[i].name, from, to ) );
    }
    say ( "\
+----------------------+--------------+--------------+\n" );
}

/*--------------------------------------------------------------------------*/

void print_commands ( playerno )
    int playerno;
{
    int i;
    char *c1, *c2, *c3, *c4;

    say ( "Available commands;\n\n" );
    for ( i = 0; comms[i].command; i+= 4 ) {
				/* Tedious! */
	if ( ( c1 = comms[i].command ) == 0 )
	    c1 = "";
	if ( ( c2 = comms[i+1].command ) == 0 )
	    c2 = "";
	if ( ( c3 = comms[i+2].command ) == 0 )
	    c3 = "";
	if ( ( c4 = comms[i+3].command ) == 0 )
	    c4 = "";
	say ( form ( "%-19s %-19s %-19s %-19s\n",
		    c1, c2, c3, c4 ) );
    }
}

/*--------------------------------------------------------------------------*/

void eat ( playerno, command )
    int   playerno;
    char *command;
{
    char itemstr[LINELEN];
    int  ind, count = 0;

    while ( *command != '\0' ) {
	count++;

	getnextobject ( itemstr, command );

	if ((ind = strtonoun ( itemstr, player[playerno].invloc)) == -1) {
	    say (form ("I don't know what a \"%s\" is.\n", itemstr));
	    continue;
	}

	if (!reallyheld (ind, playerno)) {
	    say ( form ( "You don't have the %s!\n", obj[ind].desc ) );
	    continue;
	}

	if (!accessheld (ind, playerno)) {
	    say ( form ( "You can't get at the %s right now.\n",
			obj[ind].desc ) );
	    continue;
	}
	if ( !moveablep(ind)) {
	    say ( form ( "You can't eat the %s, you peasant!\n",
			obj[ind].desc ) );
	    continue;
	}
	if ( !ediblep(ind)) {
	    say ( form ( "You can't eat the %s!\n", obj[ind].desc ) );
	    continue;
	}

	say ( form ( "You devour the %s.\n", obj[ind].desc ) );
	speak ( form ( "You see %s eat a %s.\n", 
		      player[playerno].name,
		      obj[ind].desc ),
	       playerno,
	       player[playerno].where );

	obj[ind].location = UPITLOC;

	if ( change_intcont ( playerno, totalintweight(ind) ) )
	    return;
    }

    if ( ! count )
	say ( "Eat what?\n" );
}


/*--------------------------------------------------------------------------*/

void win ( playerno )
    int playerno;
{
    if ( ! WIZMODEP ( playerno ) ) {
	say ( "Sorry, only wizards can win the game!\n" );
	return;
    }
    say ( "\n\
\t\t*** You have WON the game, well done! ***\n\
\n\
Your name will be added to the list of MUNDI winners, which of course will\n\
be published as soon as it can be retrieved from /dev/null.\n\
\n" );
    shout ( form ( "*** %s has WON mundi! ***\n", player[playerno].name ),
	   playerno, MESG_GLOBAL );
}

/*--------------------------------------------------------------------------*/

void lockstring ( playerno, args, command )
    int playerno;
    char *args;
    char *command;
{
    /* [un]lock item [with] item */
    char itemstr[LINELEN];
    char keystr[LINELEN];
    int item, key, unlock = (strcmp ( command, "unlock" ) == 0);

    getnextword ( itemstr, args );
    if ((item = strtonoun ( itemstr, player[playerno].invloc)) == -1) {
	say ( form ( "I don't know what a \"%s\" is.\n", itemstr ) );
	return;
    }

    getnextword ( keystr, args );
    if ( samenstring ( "with", keystr ) )
	getnextword ( keystr, args );
    
    if ((key = strtonoun ( keystr, player[playerno].invloc)) == -1) {
	say ( form ( "I don't know what a \"%s\" is.\n", keystr ) );
	return;
    }

    if (!reallyheld (key, playerno)) {
	say ( form ( "You don't have the %s.\n", obj[key].desc) );
	return;
    }

    if (!visible (item, playerno)) {
	say ( form ( "You can't see any %s.\n", obj[item].desc) );
	return;
    }

    if (!accessheld (key, playerno)) {
	say ( form ( "You can't get at the %s.\n", obj[key].desc) );
	return;
    }
    if (!accessible (item, playerno)) {
	say ( form ( "You can't get at the %s.\n", obj[item].desc) );
	return;
    }
    if (!moveablep (key)) {
	say ( form ( "You can't seem to move the %s.\n",
		    obj[key].desc ) );
	return;
    }

    if ( ! lockablep ( item ) ) {
	say ( form ( "The %s doesn't have a lock!\n", itemstr ) );
	return;
    }

    if ( objectkey(item) != key ) {
	say ( form ( "The %s doesn't fit the locks on the %s!\n",
		    keystr, itemstr ) );
	return;
    }
				/* If locking and locked OR */
				/*   unlocking and unlocked */
				/* Then SILLY */
    if (   (!unlock && lockedp   ( item ))
	|| ( unlock && unlockedp ( item )) ) {
	say ( form ( "The %s is already %sed!\n", itemstr, command ) );
	return;
    }


    if ( unlock )
	obj[item].container &= ~32;
    else
	obj[item].container |= 32;
    
    say ( form ( "You %s the %s with the %s.\n", command, itemstr, keystr ) );
}

